quoter/forms/__init__.py
from ..forms.forms import *

quoter/forms/forms.py
"""Forms.py."""
from wtforms import Form, PasswordField, TextField, validators


class RegistrationForm(Form):
    """Registration form."""

    username = TextField(
        (u'What do you want us to call you?'),
        [validators.Length(min=3, max=15), validators.Required()]
    )
    email = TextField(
        (u'Email Address'), [validators.Length(min=6, max=35)]
    )
    password = PasswordField((u'Password'), [
        validators.Required(),
        validators.EqualTo(
            u'confirm', message=(u'Passwords must match')
        ),
        validators.Length(min=6, max=16)
    ])
    confirm = PasswordField((u'Repeat Password'))


class LoginForm(Form):
    """Login Form."""

    email = TextField(
        (u'Email Address'), [validators.Length(min=6, max=35)]
    )
    password = PasswordField((u'Password'), [
        validators.Required(),
    ])


class ResetPasswordForm(Form):
    """Reset Password Form."""

    email = TextField(
        (u'Email Address'), [validators.Length(min=6, max=35)]
    )


class ConfirmResetPasswordForm(Form):
    """Reset Password Form."""

    password = PasswordField((u'Password'), [
        validators.Required(),
        validators.EqualTo(
            u'confirm', message=(u'Passwords must match')
        ),
        validators.Length(min=6, max=16)
    ])
    confirm = PasswordField((u'Repeat Password'))

quoter/__init__.py
import os
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_mail import Mail



def import_modules():
    from . import views
    from . import models
    from . import logs
    from . import admin


############
# APP INIT #
############
app = Flask(__name__, static_folder = '../dist')
#  load settings from Config class,
#  depending on environmental variable
app.config.from_object(os.environ['APP_SETTINGS'])
db = SQLAlchemy(app)
mail = Mail(app)


# import into module namespace
import_modules()

quoter/logs/__init__.py
from logger import logger, syslog, loglevel

quoter/views/__init__.py
from .. import app
from ..views.auth import auth
from ..views.main import main

app.register_blueprint(auth)
app.register_blueprint(main)

quoter/views/auth.py
"""Authentication views blueprint."""
import datetime
from flask import Blueprint, flash, g, redirect, render_template, request, \
    url_for
from flask_login import LoginManager, current_user, login_required,  \
    login_user, logout_user

# namespace .quoter
from .. import app, db
from ..decorators import check_confirmed
from ..logs import logger
from ..email import send_email
from ..models import User
from ..forms import LoginForm, RegistrationForm, ResetPasswordForm,\
    ConfirmResetPasswordForm


auth = Blueprint('auth', __name__)


###############
# LOGIN UTILS #
###############
login_manager = LoginManager()
login_manager.init_app(app)
login_manager.login_view = 'auth.login'


@login_manager.user_loader
def load_user(id):
    return User.query.get(int(id))


@app.before_request
def before_request():
    g.user = current_user


##############
#  Register  #
##############
def send_confirm_email(user_email=None, username=None, confirm_url=None):
    """Send confirm email address."""
    if app.config['TESTING']:
        msg = 'Email not sent. You are in TESTING mode!'
        print(msg)
        logger.info(msg)
        return True
    root_url = app.config.get('ROOT_URL')
    with app.app_context():
        html = render_template(
            'user/activate.html',
            confirm_url=confirm_url,
            username=username,
            root_url=root_url
        )
        subject = 'Please confirm your email'
        try:
            send_email(user_email, subject, html)
            logger.info(
                'confirmation email sent to {}'.format(user_email)
            )
            return True
        except Exception as e:
            logger.error(
                'confirmation email could not be sent. User {0}. Error {1}'
                .format(user_email, e)
            )
            return False


@auth.route('/register', methods=['GET', 'POST'])
def register():
    """Register user."""
    form = RegistrationForm(request.form, country='CL')
    if request.method == 'POST' and form.validate():
        email_exists = User.query.filter_by(email=form.email.data).first()
        if email_exists:
            flash(u'Email address already exists', 'warning')
        else:
            user = User(
                username=form.username.data,
                email=form.email.data,
            )
            user.hash_password(form.password.data)
        try:
            db.session.add(user)
            db.session.commit()
            #  generate token and send email
            token = generate_confirmation_token(user.email)
            confirm_url = url_for(
                'auth.confirm_email',
                token=token,
                _external=True
            )
            send_confirm_email(
                user_email=user.email,
                confirm_url=confirm_url,
                username=user.username
            )
            logger.info(
                'new user registered. {}'.format(user)
            )
            flash(
                'Thanks for registering with us. \
                A confirmation email has been sent via email.', 'success'
            )
        except Exception as e:
            # TODO deal with duplicate email addresses
            db.session.rollback()
            logger.error(
                'new user could not be registered. {0}'.format(e)
            )
        finally:
            db.session.close()
        return redirect(url_for('auth.login'))
    return render_template(
        'register.html',
        form=form,
    )


@auth.route('/unconfirmed')
def unconfirmed():
    """Return unconfirmed template."""
    if hasattr(current_user, 'confirmed') and current_user.confirmed:
        return redirect(url_for('auth.login'))
    flash('Please confirm your account!', 'warning')
    return render_template('unconfirmed.html')


@auth.route('/confirm/<token>')
def confirm_email(token):
    """Confirm token with email address using token."""
    user = None
    email = confirm_token(token)
    if email:
        try:
            user = User.query.filter_by(email=email).first()
        except Exception as e:
            flash(
                'Sorry, we could not find your account in our database.', 'warning'
            )
            logger.error('error {}. email {}'.format(e, email))
        if not user:
            logger.error(
                'user could not be confirmed. email {}'.format(email)
            )
            flash('We could not verify your email address.', 'warning')
            return redirect(url_for('auth.register'))
        if user.confirmed:
            flash('Account already confirmed. Please login.', 'success')
        else:
            user.confirmed = True
            user.confirmed_on = datetime.datetime.now()
            try:
                db.session.add(user)
                db.session.commit()
                logger.info(
                    'user confirmed. {}'.format(user)
                )
            except Exception as e:
                db.session.rollback()
                logger.error(
                    'user could not be confirmed. {0}. {1}'.format(user, e)
                )
                raise
            finally:
                db.session.close()
            flash('You have confirmed your account. Thanks!', 'success')
    else:
        flash('The confirmation link is invalid or has expired.', 'warning')
    return redirect(url_for('auth.login'))


@auth.route('/reset_password', methods=['GET', 'POST'])
@check_confirmed
def reset_password():
    """Request password reset."""
    form = ResetPasswordForm(request.form)
    if request.method == 'POST' and form.validate():
        #  check user email exists
        email = request.form['email'].strip()
        user = User.query.filter_by(email=email).first()
        if user:
            token = generate_confirmation_token(user.email)
            confirm_url = url_for(
                'auth.confirm_reset_password',
                token=token,
                _external=True
            )
            html = render_template(
                'user/password_reset_email.html',
                confirm_url=confirm_url,
                username=user.username
            )
            subject = "Password Reset Request"
            send_email(email, subject, html)
            msg = 'Password reset request email sent to {}'.format(user.email)
            logger.info(msg)
            flash(msg, 'success')
            return redirect(url_for('auth.login'))
        #  flash('Email address not found for any user', 'warning')
        flash(
            'Email address not found for any user',
            'warning'
        )
    return render_template(
        'reset_password_request.html',
        form=form
    )


@auth.route('/confirm_reset_password/<token>', methods=['GET', 'POST'])
@check_confirmed
def confirm_reset_password(token):
    """Confirm password reset."""
    form = ConfirmResetPasswordForm(request.form)
    if request.method == 'POST' and form.validate():
        try:
            email = confirm_token(token)
        except Exception as e:
            flash(
                'The confirmation link is invalid or has expired.',
                'warning'
            )
        user = User.query.filter_by(email=email).first_or_404()
        if not user.confirmed:
            flash(
                'You must confirm your account first',
                'warning'
            )
        else:
            pwd = request.form['password'].strip()
            user.hash_password(pwd)
            try:
                db.session.add(user)
                db.session.commit()
                logger.info(
                    'Password reset. {}'.format(user)
                )
            except Exception as e:
                db.session.rollback()
                error_msg = 'Your password could not be changed at this time. \
                    {}'.format(user)
                logger.error('{0} {1}'.format(error_msg, e))
                flash(error_msg, 'warning')
                raise
            finally:
                db.session.close()
            flash('You have successfully changed your password.', 'success')
            return redirect(url_for('auth.login'))
    return render_template(
        'reset_password_confirm.html',
        token=token,
        form=form
    )


@auth.route('/login', methods=['GET', 'POST'])
def login():
    """User login."""
    form = LoginForm(request.form)
    # is user authenticated go straight to default template
    if g.user.is_authenticated:
        return redirect(url_for('index'), code=302)
    if request.method == 'POST' and form.validate():
        email = request.form['email']
        password = request.form['password']
        registered_user = User.query.filter_by(
            email=email
        ).first()
        if registered_user is None or not registered_user.verify_password(password):
            msg = 'Email or Password is invalid'
            logger.info(
                '{0} email: {1}'.format(msg, email)
            )
            flash(msg, 'warning')
            return redirect(url_for('auth.login'))
        if not registered_user.confirmed:
            logger.info(
                'unconfirmed user login attempt. email: {0}'.format(email)
            )
            return redirect(url_for('auth.unconfirmed'))
        login_user(registered_user)
        logger.info(
            'user login.  user: {0}'.format(current_user)
        )
        return redirect(url_for('index'), code=302)
    return render_template(
        'login.html',
        form=form
    )


@auth.route('/logout')
@login_required
def logout():
    """User logout."""
    logger.info(
        'user logout. user: {0}'.format(current_user)
    )
    logout_user()
    return redirect(url_for('auth.login'))

quoter/views/main.py
import json
from flask import Blueprint, render_template, request, redirect, g, url_for
from flask_login import current_user
from .. import app, db
from ..decorators import check_confirmed
from ..models import Driver, VehicleForm, Vehicle, HomeForm


main = Blueprint('main', __name__)


def save_driver(driver):
    driver = Driver(
        full_name=driver['fullName'],
        drivers_license=driver['driversLicense'],
        mailing_address=driver['mailingAddress'],
        date_of_birth=driver['dateOfBirth'],
        tickets=driver['tickets']
    )
    return driver


def save_vehicle(vehicle):
    vehicle = Vehicle(
        vin=vehicle['vin'],
        year=vehicle['year'],
        make=vehicle['make'],
        model=vehicle['model'],
        coverage=vehicle['coverage'],
        use=vehicle['use']
    )
    return vehicle



def save_vehicle_form(form, user, driver):
    print('vehicle form {}'.format(form))
    vehicle_form = VehicleForm(
        user=user,
        primary_driver=driver,
        college_grads=form['collegeGrads'],
        college_grads_details=form['collegeGradsDetails'],
        medical_coverage=form['medicalCoverage'],
        current_billing=form['currentBilling'],
        coverage_required=form['coverage'],
        use=form['use'],
    )
    for vehicle in form['vehicles']:
        v = save_vehicle(vehicle=vehicle)
        vehicle_form.vehicles.append(v)
    for additional_driver in form['additionalDrivers']:
        d = save_driver(driver=additional_driver)
        vehicle_form.additional_drivers.append(d)
    return vehicle_form


def save_home_form(form, user):
    home_form = HomeForm(
        user=user,
        full_name=form['fullName'],
        age=form['age'],
        basement_exists=form['basementExists'],
        basement_percent_finished=form['basementPercentFinished'],
        recent_loss=form['recentLoss'],
        wood_stove=form['woodStove'],
        current_billing=form['currentBilling']
    )
    return home_form

# -------- ROUTES -------------------------------------
@check_confirmed
@app.route('/', methods=['GET', 'POST'])
def index():
    """Index."""
    if not g.user.is_authenticated:
        return redirect(url_for('auth.login'))
    return render_template('index.html')


@app.route('/success', methods=['GET'])
def success():
    """Success."""
    return 'SUCCESS!'



@app.route('/save', methods=['GET', 'POST'])
def save():
    """Save Form."""
    form = None
    if request.method == 'POST' and request.data:
        form = json.loads(request.data)['data']
        # debug ----
        print('user: {}'.format(current_user))

        #  save vehicle data
        if form['type'] == 'vehicle':    
            driver = save_driver(
                driver=form['primaryDriver']
            )
            vehicle_form = save_vehicle_form(
                form=form,
                user=current_user,
                driver=driver
            )
            db.session.add(driver)
            db.session.add(vehicle_form)
            db.session.commit()
        
        #  save home data
        if form['type'] == 'home':
            home_form = save_home_form(
                form=form,
                user=current_user
            )
            db.session.add(home_form)
            db.session.commit()

        #  on success redirect to a success page
        return redirect(url_for('success'))
    return json.dumps(form)

quoter/templates/_formhelpers.html
{% macro render_field(field) %}
  <dt>{{ field.label }}
  <dd>{{ field(**kwargs)|safe }}
  {% if field.errors %}
    <ul class=errors>
    {% for error in field.errors %}
      <li>{{ error }}</li>
    {% endfor %}
    </ul>
  {% endif %}
  </dd>
{% endmacro %}

quoter/templates/base.html
<!doctype html>
<html class="no-js" lang="">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    {% block title %}
    <title>Insurance Quoter</title>
    {% endblock %}
    <meta name="description" content="">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <link rel="apple-touch-icon" href="apple-touch-icon.png">
    <!-- Place favicon.ico in the root directory -->
    
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link type="text/css" rel="stylesheet" href="{{ url_for('static', filename='style.css' )}}">

  </head>
  <body>
    <!--[if lt IE 8]>
      <p class="browserupgrade">You are using an <strong>outdated</strong> browser. Please <a href="http://browsehappy.com/">upgrade your browser</a> to improve your experience.</p>
    <![endif]-->

    <!-- navigation -->
    <nav class="_container">
      <a class="btn btn-primary" href="{{ url_for('index') }}">Home</a>
      {% if g.user.is_authenticated and g.user.role == 'admin' %}
      <a class="btn btn-primary" style="background: black; border: 1px solid black" href="{{ url_for('admin.index') }}">Admin</a>
      {% endif %}
      {% if g.user.is_authenticated %}
      <a class="btn btn-danger" href="{{ url_for('auth.logout') }}">Logout</a>
      <!--<a class="btn btn-primary" href="{{ url_for('auth.reset_password') }}">Change Password</a>-->
      {% else %}
      <a class="btn btn-primary" href="{{ url_for('auth.register') }}">Register</a>
      <a class="btn btn-primary" href="{{ url_for('auth.login') }}">Login</a>
      {% endif %}
      <hr />
    </nav>
    <!-- / navigation -->
    
    <!-- messages -->
    {% with messages = get_flashed_messages(with_categories=true) %}
    {% if messages %}
    <div class="_container">
      {% for category, message in messages %}
        <div class="message-card {{ category }}">{{ message }}</div>
      {% endfor %}
    </div>
    {% endif %}
    {% endwith %}
    <!-- / messages -->
    
    <!-- main content -->
    <main>
    {% block content %}
    {% endblock %}
    </main>
    <!-- / main content -->

    <script src="../../dist/build.js"></script>
  </body>
</html>

quoter/templates/index.html
{% extends 'base.html' %}

{% block content %}
  <div id="app"></div>
  <script src="../../dist/build.js"></script>
{% endblock %}

quoter/templates/login.html
{% extends "base.html" %}

{% block content %}
{% from "_formhelpers.html" import render_field %}

<div class="_container">
  <form method=post action="{{ url_for('auth.login') }}">
    <dl>
      {{ render_field(form.email) }}
      {{ render_field(form.password) }}
    </dl>
    <p><input type=submit value=Login></p>
  </form>

  <a href="{{ url_for('auth.reset_password') }}">Forgot Password?</a>
</div>

{% endblock %}

quoter/templates/register.html
{% extends "base.html" %}
{% block content %}
{% from "_formhelpers.html" import render_field %}

<div class="_container">
  <form method=post action="{{ url_for('auth.register') }}">
    <dl>
      {{ render_field(form.username) }}
      {{ render_field(form.email) }}
      {{ render_field(form.password) }}
      {{ render_field(form.confirm) }}
    </dl>
    <p><input type=submit value=Register></p>
  </form>
</div>

{% endblock %}

quoter/templates/reset_password_confirm.html
{% extends "base.html" %}

{% from "_formhelpers.html" import render_field %}
{% block content %}

<div class="_container">
  <form method=post action="{{ url_for('auth.confirm_reset_password', token=token) }}">
    <dl>
      {{ render_field(form.password) }}
      {{ render_field(form.confirm) }}
    </dl>
    <p><input type=submit value=Submit></p>
  </form>
</div>
{% endblock %}

quoter/templates/reset_password_request.html
{% extends "base.html" %}

{% block content %}
{% from "_formhelpers.html" import render_field %}

<div class="_container">
  <form method=post action="{{ url_for('auth.reset_password') }}">
    <dl>
      {{ render_field(form.email) }}
    </dl>
    <p><input type=submit value=Submit></p>
  </form>
</div>
{% endblock %}

quoter/templates/unconfirmed.html
{% extends "base.html" %}

{% block content %}
<div class="_container">
  <p>You have not confirmed your account. Please check your inbox (and your spam folder) - you should have received an email with a confirmation link.</p>
</div>
<!--<p>Didn't get the email? <a href="/">Resend</a>.</p>-->

{% endblock %}